#! /bin/sh

# Prfen, ob der Listenname keine Domain enthlt
if [[ "$listname" != "${listname%@*}" ]]; then
	echo "Fehler: Bitte keine Domain mit angeben. Da Mailman das nicht sauber"
	echo "untersttzt fhrt das nur zu Konfigurationsproblemen."
	exit 1
fi

# Listennamen herausfinden
param_before=""
listname=""
for param in $@; do
	if [[ "$listname" == "" && "${param:0:1}" != "-" && \
		"$param_before" != "-l" && "$param_before" != "--language" ]]; then
		listname=$param
	fi
	param_before=$param
done

if [[ "$listname" == "" ]]; then
	echo "Fehler: Der Listenname MUSS als Parameter angegeben werden."
	/usr/sbin/newlist.distrib -h
	exit 1
fi

# Liste in Mailman einrichten
/usr/sbin/newlist.distrib $@

if [[ $? != 0 ]]; then
	exit $?
fi

# Abfrage, ob die Liste von der Datenbank verwaltet werden soll
REPLY="X"
while [[ "$REPLY" != "Y" && "$REPLY" != "N" ]]; do
	echo -n "Soll die Liste die Mitglieder in der PostgreSQL-Datenbank verwalten? [Y,n] "
	read
	if [[ "$REPLY" == "y" || "$REPLY" == "" || "$REPLY" == "j" || "$REPLY" == "J" ]]; then
		REPLY="Y"
	fi
	if [[ "$REPLY" == "n" ]]; then
		REPLY="N"
	fi
done
if [[ "$REPLY" == "N" ]]; then
	exit 0
fi

# Moderationspasswort setzen, damit die Homepage die richtigen Cookies setzt
echo Das Moderationspasswort wird so eingestellt, dass Listenadministratoren
echo beim Homepagelogin automatisch ein gltiges Passwort-Cookie gesetzt
echo kriegen:
/usr/local/sbin/change_listmod_pw -l $listname -p sonnenschein -q

# Datenbank-Einrichtung
cat <<EOF > /var/lib/mailman/lists/$listname/pgsql.py
DATABASE = 'fsmi'
TABLE = 'mailman_view'

FIELD_LISTNAME = 'listenname'
FIELD_KEY = 'benutzer_id'
FIELD_MAILADDR = 'email_adresse'
FIELD_PASSWORD = 'NULL'
FIELD_DIGEST = 'digest'
FIELD_LANGUAGE = "'de'"
FIELD_OPTIONS = 'options'
FIELD_NAME = 'voller_name'

LISTCONDITION = "listenname='$listname'"
EOF

cat <<EOF > /var/lib/mailman/lists/$listname/extend.py
from Mailman.PostgreSQLMemberships import PostgreSQLMemberships

def extend(list):
    list.NO_LISTCACHE = True
    list._memberadaptor = PostgreSQLMemberships(list)
EOF

echo Trage neue Liste in die Datenbank ein
cat <<EOF | sudo -u list psql -e fsmi
INSERT INTO mailinglisten (name, htmlname, benachrichtigung_an)
VALUES ('$listname', '$listname@fsmi.uni-karlsruhe.de', '$listname@fsmi.uni-karlsruhe.de');
EOF
